# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc商品包装确认删除功能验证,33,33-17,sit,be
主数据平台:后台运营系统商品包装确认删除接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import json
import os

module = "cmdc_33st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers_file", cmdc_access_token)

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/商品包装管理批量删除导入模板_导入成功.xlsx"

# 第二步批量删除商品包装信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url12")

# 获取文件
file = open(file_path, "rb")
files = {"file": file}

# 发送请求
result = requests.post(url, files=files, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取删除商品信息
result = json.loads(result.content)
packagingId = result["data"][0]["packagingId"]

"""
 场景:商品包装确认删除功能验证
 用例名称：商品包装确认删除功能验证
 输出：{"success":true,"code":"200","message":null,"data":null,"freshToken":null}
"""

# 第三步进行删除二次确认
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url17")
requests_body = [packagingId]

# 发送请求
result = requests.post(url, json=requests_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 将接口响应时间添加至result
result = json.loads(result.content)
print(result)
result["api_time"] = api_time
file.close()

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict17")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

