# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_主站点专区列表,2299,2299-33,sit,bs
主数据平台:后台运营系统获取主站点专区列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import datetime
import random
import json

module = "cmdc_area"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username0")
password = commonFuc().get_business_data(module, "password0")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取主站点专区列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url32")
request_body = commonFuc().get_business_data(module, "payload32")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
site_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取站点专区信息
title = result["data"]["list"][site_random]["title"]
description = result["data"]["list"][site_random]["description"]
disableSign = result["data"]["list"][site_random]["disableSign"]
terminalType = result["data"]["list"][site_random]["terminalType"]
startTime = result["data"]["list"][site_random]["createTime"][:10]
endTime = datetime.datetime.now().strftime("%Y-%m-%d")

# 第三步进行列表条件查询
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url33")
request_body = commonFuc().get_business_data(module, "payload33", title, description, disableSign, terminalType,
                                             startTime, endTime)
"""

 场景: 列表查询条件验证_主站点专区列表
 用例名称：列表查询条件验证_主站点专区列表
 输出：{"title":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取专区信息
result = json.loads(result.content)
result = {"title": result["data"]["list"][0]["title"]}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict33", title)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
