# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc购物车列表查询条件验证,2252,2252-16,sit,bs
涉及到接口:购物车列表、购物车新增商品等接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.多采商城登录.多采商城登录 import CmdcMaiiLogin
import requests
import json


module = "cmdc_buyercart_handle"

# 第一步登录多采商城获取token信息
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username")
password = commonFuc().get_business_data(module, "password")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcMaiiLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步新增商品至购物车列表
url_add = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url_add")
# 发送请求
request_body2 = commonFuc().get_business_data(module, "payload3")
result2 = requests.post(url_add, json=request_body2, headers=headers)

"""
 场景:购物车列表查询条件验证
 用例名称：购物车列表查询条件验证
 输出：{"success":true,"code":"200","message":"OK","data":"ok"}
"""

# 第三步根据查询条件查询数据并进行数据验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url")
request_body = commonFuc().get_business_data(module, "payload8")
# print(request_body)
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = result.elapsed.total_seconds()
result = json.loads(result.content)

# 获取查询结果中商品id
result = {"productId": result["data"]["list"][0]["list"][0]["productId"]}
result["api_time"] = api_time
# # 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict3")
# # 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
