# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc新老编码替换明细导出验证,2264,2264-79,sit,bs
主数据平台:运营后台管理系统新老商品编码替换明细导出接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import random
import json
import os


module = "cmdc_special_fresenius_group"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步新老编码替换列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url_product_code")
request_body = commonFuc().get_business_data(module, "payload_product_code")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
# 生成随机数
dis_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取商品新老编码替换信息
group_code = result["data"]["list"][dis_random]["groupCode"]
product_code = result["data"]["list"][dis_random]["products"][0]["productCode"]
productLineName = result["data"]["list"][dis_random]["productLineName"]
# 第三步进行商品新老编码明细导出
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url60")
request_body = commonFuc().get_business_data(module, "payload60", productLineName)

"""
 场景: 验证商品新老编码替换列表明细导出接口联通性以及数据的正确性
 用例名称：新老编码替换明细导出验证
 输出：{"productLineName":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/新老商品编码关系导出明细.xlsx"

# 获取到导出文件存入cmdc_files文件中
with open(file_path, 'wb') as f:
    f.write(result.content)

# 获取导出文件中子需求单
excel = HandleExcel(file_path, "Sheet1")
# print(excel.read_data())
result = {"productLineName": excel.read_data()[0].get("产品线")}

# 将接口响应时间添加至结果中
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict60", productLineName)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)


